Summary: Basic authentication for the Apache web server using an external program
Name: mod_auth_external
Version: 2.2.8
Release: %smerelease 2
Packager: %{_packager}
Group: System Environment/Daemons
URL: http://unixpapa.com/mod_auth_external.html
Source: mod_auth_external-2.2.8.tar.gz
Source2: auth_external.conf
Patch0: mod_auth_external-config.patch
Patch1: mod_auth_external-no_server_uids.patch
License: Apache Software License
BuildRoot: %{_tmppath}/%{name}-root
BuildPrereq: httpd-devel >= 2.0.40-12
Requires: httpd >= 2.0.40
#Requires: httpd-mmn = %(cat %{_includedir}/httpd/.mmn)

%description
mod_auth_external can be used to limit access to documents served by a
web server by checking data in an external program.

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1
%patch1 -p1

%build
%{_sbindir}/apxs -DAPACHE2 -c %{name}.c
mv .libs/%{name}.so .
%{__strip} -g %{name}.so
%{__cc} -o pwauth/pwauth pwauth/pwauth.c -lpam -ldl
%{__strip} pwauth/pwauth

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_docdir}/mod_auth_external-%{version}
mkdir -p $RPM_BUILD_ROOT%{_libdir}/httpd/modules
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
install -m755 %{name}.so $RPM_BUILD_ROOT%{_libdir}/httpd/modules
install -m755 pwauth/pwauth $RPM_BUILD_ROOT%{_libdir}/httpd/modules

# Install the config file
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
install -m 644 $RPM_SOURCE_DIR/auth_external.conf \
   $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/
mv pwauth/README pwauth/README.pwauth
cat > ${RPM_BUILD_ROOT}/etc/pam.d/pwauth <<EOF
#%PAM-1.0
auth       required     /lib/security/pam_pwdb.so shadow nullok
auth       required     /lib/security/pam_nologin.so
account    required     /lib/security/pam_pwdb.so
EOF

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README INSTALL pwauth/README.pwauth
%attr(0444,root,root) /etc/pam.d/pwauth
%attr(04550,root,www) %{_libdir}/httpd/modules/pwauth
%{_libdir}/httpd/modules/*.so
%config(noreplace) %{_sysconfdir}/httpd/conf.d/*.conf

%changelog
* Thu Dec 07 2006 Shad L. Lords <slords@mail.com>
- Update to new release naming.  No functional changes.
- Make Packager generic

* Mon Mar 20 2006 Charlie Brady <charlieb@e-smith.com> 2.2.8-1sme03
- Remove redundant SERVER_UID checking - that is taken care of by
  file system permissions. [SME: 1037]

* Wed Apr 20 2005 Charlie Brady <charlieb@e-smith.com> 2.2.8-1sme02
- Change group of executable from admin to www, so that both apache
  instances can authenticate. Add 102 to SERVER_UIDS to cover both
  newly installed and upgraded systems.

* Tue Aug 10 2004 Shad L. Lords <slords@mail.com>
- initial package
